﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CampusTableAdapters;

/// <summary>
/// CursosBLL és la capa de negoci que connecta la capa de presentació amb el DataTable Curs 
/// de la capa d’accés a dades (DAL) anomenada Campus.
/// </summary>



[System.ComponentModel.DataObject]
public class CursosBLL
{

    //Preparem l'accés a Curs.
    private CursTableAdapter _productsAdapter = null;
    protected CursTableAdapter Adapter
    {
        get
        {
            if (_productsAdapter == null)
                _productsAdapter = new CursTableAdapter();

            return _productsAdapter;
        }
    }



    //Accés als cursos.
    [System.ComponentModel.DataObjectMethodAttribute
        (System.ComponentModel.DataObjectMethodType.Select, true)]
    public Campus.CursDataTable GetCurs()
    {
        return Adapter.GetCurs();
    }




    //Accés a un curs.
    [System.ComponentModel.DataObjectMethodAttribute
        (System.ComponentModel.DataObjectMethodType.Select, false)]
    public Campus.CursDataTable GetCursByCodiCurs(int codi_curs)
    {
        return Adapter.GetCursByCodiCurs(codi_curs);
    }



    //Inserció d'un curs.
    [System.ComponentModel.DataObjectMethodAttribute
    (System.ComponentModel.DataObjectMethodType.Insert, true)]
    public bool InsertCurs(int codi_curs, string nom, string descripcio, DateTime data_inici, DateTime data_finalitzacio)
    {


        Campus.CursDataTable cursos = new Campus.CursDataTable();
        Campus.CursRow curs = cursos.NewCursRow();

        //Assignem un codi de curs adient.
        Campus.CursDataTable files = Adapter.GetCurs();
        int b = 1;
        //int a = files.Count;
        int a=0;
        
        while (b != 0)
        {
            a = a + 1;
            Campus.CursDataTable cursos2 = Adapter.GetCursByCodiCurs(a);
            b = cursos2.Count;

        }

        curs.codi_curs = a;

        //Assignem la resta d'atributs.
        if (nom == null) curs.SetnomNull();
        else curs.nom = nom;
        if (descripcio == null) curs.SetdescripcioNull();
        else curs.descripcio = descripcio;
        if (data_inici == null) curs.Setdata_iniciNull();
        else curs.data_inici = data_inici;
        if (data_finalitzacio == null) curs.Setdata_finalitzacioNull();
        else curs.data_finalitzacio = data_finalitzacio;


        //Afegim el nou curs.
        cursos.AddCursRow(curs);
        int rowsAffected = Adapter.Update(cursos);

        //Retorna cert si el registre s'inserta
        //o fals en cas contrari.
        return rowsAffected == 1;
    }



    //Actualització d'un curs.
    [System.ComponentModel.DataObjectMethodAttribute
     (System.ComponentModel.DataObjectMethodType.Update, true)]
    public bool UpdateCurs(int codi_curs, string nom, string descripcio, DateTime data_inici, DateTime data_finalitzacio)
    {
        //Si el material no existeix retorna fals.
        Campus.CursDataTable cursos = Adapter.GetCursByCodiCurs(codi_curs);
        if (cursos.Count == 0)
            return false;

        Campus.CursRow curs = cursos[0];

        if (nom != null) curs.nom = nom;
        if (descripcio != null) curs.descripcio = descripcio;
        if (data_inici != null) curs.data_inici = data_inici;
        if (data_finalitzacio != null) curs.data_finalitzacio = data_finalitzacio;

        //Actualització del curs.
        int rowsAffected = Adapter.Update(curs);

        //Retorna cert si el registre s'actualitza
        //o fals en cas contrari.
        return rowsAffected == 1;
    }



    //Esborrament d'un curs.
    [System.ComponentModel.DataObjectMethodAttribute
    (System.ComponentModel.DataObjectMethodType.Delete, true)]
    public bool DeleteCurs(int codi_curs)
    {
        int rowsAffected = Adapter.DeleteCurs(codi_curs);

        //Retorna cert si el registre s'esborra
        //o fals en cas contrari.
        return rowsAffected == 1;
    }


}