﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Cursos_Alumnat_Curs_01_Consultes_AfegirConsultaCurs_01 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    //Seleccionem només les consultes de l’usuari actiu.
    protected void ObjectDataSource9_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["nom_alumne"] = User.Identity.Name;
        
    }

    //S’insereix una consulta en el curs i amb l’usuari actius.
    protected void ObjectDataSource9_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["codi_curs"] = "01";
        e.InputParameters["nom_alumne"] = User.Identity.Name;
    }


    //S'actualitza el fitxer associat a la consulta.
    protected void ItemInserting2(object sender, DetailsViewInsertEventArgs e)
    {
        FileUpload ConsultaUpload = (FileUpload)DetailsView2.FindControl("ConsultaUpload");

        //Comprovem si existeix un fitxer de consulta.
        if (ConsultaUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }

            //Es genera la ruta d'accés a la consulta.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Consultes/Consulta/";
           
            //S’afegeix el nom de l’alumne al nom del fitxer.
            string fitxer_consulta = FitxersDirectory + User.Identity.Name + "-" + ConsultaUpload.FileName;

            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(ConsultaUpload.FileName);


            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }



            //S'emmagatzema el fitxer i la seva ruta d'accés.
            ConsultaUpload.SaveAs(Server.MapPath(fitxer_consulta));
            e.Values["fitxer_consulta"] = fitxer_consulta;
        }

    }




    protected void DetailsView1_PageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {

    }


    protected void ItemInserting(object sender, DetailsViewInsertEventArgs e)
    {

    }
}