﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Cursos_Alumnat_Curs_01_Tests_LliurarTest : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    //Seleccionem només els tests de l’usuari actiu.
    protected void Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["nom_alumne"] = User.Identity.Name;
    }


    //Assignem a l’atribut “nom_test” el valor “Test 1”.
    protected void Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["nom_test"] = "Test 1"; 
        e.InputParameters["qualificacio"] = null;
    }


    protected void DetailsView1_PageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {

    }



    //Lliurament dels Test 1 per part de l’alumne.
    protected void ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {

        FileUpload LliurarTestUpload = (FileUpload)DetailsView1.FindControl("LliurarTestUpload");

        //Comprovem si existeix un fitxer a lliurar.
        if (LliurarTestUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }


            //Es genera la ruta d'accés al Test 1 lliurat.
            string nom_alumne = Convert.ToString(e.Keys["nom_alumne"]);

            const string FitxersDirectory = "~/Fitxers/Curs_01/Tests/Tests_lliurats/";

            //S’afegeix el nom de l’alumne al nom del fitxer.
            string fitxer_lliurat = FitxersDirectory + nom_alumne + "-" + LliurarTestUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(LliurarTestUpload.FileName);
        

            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_lliurat)))
                {
                    fitxer_lliurat = string.Concat(FitxersDirectory, nom_alumne, "-", fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_lliurat)))
                {
                    fitxer_lliurat = string.Concat(FitxersDirectory, nom_alumne, "-", fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_lliurat)))
                {
                    fitxer_lliurat = string.Concat(FitxersDirectory, nom_alumne, "-", fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(LliurarTestUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_lliurat)))
                {
                    fitxer_lliurat = string.Concat(FitxersDirectory, nom_alumne, "-", fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }
           

            //S'emmagatzema el fitxer i la seva ruta d'accés.
            LliurarTestUpload.SaveAs(Server.MapPath(fitxer_lliurat));
            e.NewValues["fitxer_lliurat"] = fitxer_lliurat;
        }
        

    }



}