﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Cursos_Alumnat_Curs_01_Consultes_AfegirConsultaCurs_01 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void ObjectDataSource9_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        
        
    }

    //L’usuari actiu contesta una pregunta del curs actiu.
    protected void ObjectDataSource9_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["codi_curs"] = "01";
        e.InputParameters["nom_alumne"] = User.Identity.Name;
    }



    //S'actualitza el fitxer associat a la consulta.
    protected void ItemInserting2(object sender, DetailsViewInsertEventArgs e)
    {
        FileUpload ConsultaUpload = (FileUpload)DetailsView2.FindControl("ConsultaUpload");

        //Comprovem si existeix un fitxer de consulta.
        if (ConsultaUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }

            //Es genera la ruta d'accés a la consulta.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Consultes/Consulta/";
           
            //S’afegeix el nom del professor al nom del fitxer.
            string fitxer_consulta = FitxersDirectory + User.Identity.Name + "-" + ConsultaUpload.FileName;


            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(ConsultaUpload.FileName);


            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(ConsultaUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_consulta)))
                {
                    fitxer_consulta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }



            //S'emmagatzema el fitxer i la seva ruta d'accés.
            ConsultaUpload.SaveAs(Server.MapPath(fitxer_consulta));
            e.Values["fitxer_consulta"] = fitxer_consulta;
        }



        FileUpload RespostaUpload = (FileUpload)DetailsView2.FindControl("RespostaUpload");

        //Comprovem si existeix un fitxer de resposta.
        if (RespostaUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }

            //Es genera la ruta d'accés al fitxer.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Consultes/Resposta/";

            //S’afegeix el nom del professor al nom del fitxer.
            string fitxer_resposta = FitxersDirectory + User.Identity.Name + "-" + RespostaUpload.FileName;
            
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(RespostaUpload.FileName);
            
            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, User.Identity.Name, "-", fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }


            //S'emmagatzema el fitxer i la seva ruta d'accés.
            RespostaUpload.SaveAs(Server.MapPath(fitxer_resposta));
            e.Values["fitxer_resposta"] = fitxer_resposta;
        }

    }



    protected void DetailsView1_PageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {

    }


    protected void ItemInserting(object sender, DetailsViewInsertEventArgs e)
    {

    }



    //Inicialitzem  l’accés a la resposta.
    string deletedRespostaPath = null;

    //Es contesta una consulta existent.
    protected void ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {

        FileUpload RespostaUpload = (FileUpload)DetailsView2.FindControl("RespostaUpload");

        //Comprovem si existeix un fitxer de resposta.
        if (RespostaUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }


            //S'esborra el fitxer de resposta antic.
            int codi_consulta = Convert.ToInt32(e.Keys["codi_consulta"]);
            ConsultesBLL Consultes = new ConsultesBLL();
            Campus.ConsultesDataTable consultes = Consultes.GetConsultaByCodiConsulta(codi_consulta);
            Campus.ConsultesRow consulta = consultes[0];
            if (consulta.Isfitxer_respostaNull())
                deletedRespostaPath = null;
            else
            {
                deletedRespostaPath = consulta.fitxer_resposta;
                System.IO.File.Delete(Server.MapPath(deletedRespostaPath));
            }
            


            //Es genera la ruta d'accés al fitxer de resposta.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Consultes/Resposta/";
            string fitxer_resposta = FitxersDirectory + RespostaUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(RespostaUpload.FileName);


            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(RespostaUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_resposta)))
                {
                    fitxer_resposta = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }


            //S'emmagatzema el fitxer i la seva ruta d'accés.
            RespostaUpload.SaveAs(Server.MapPath(fitxer_resposta));
            e.NewValues["fitxer_resposta"] = fitxer_resposta;
        }


    }


}