﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Cursos_Professorat_Curs_01_Continguts_Videos_PenjarVideosCurs_01_p : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    //Creació de l'enllaç al fitxer.
    protected string GenerateFitxersLink(object contingut)
    {
        if (Convert.IsDBNull(contingut))
            //Si no hi ha cap fitxer disponible, s'informa a l'usuari.
            return "No hi ha 'Vídeos' disponibles.";
        else
            //Si hi ha un fitxer disponible, es genera un enllaç a l'esmentat fitxer.
            return string.Format(@"<a href=""{0}"">Veure 'Vídeo'.</a>", ResolveUrl(contingut.ToString()));
    }




    protected void DetailsView1_PageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {

    }


    //Inserim un nou fitxer de Vídeo.
    protected void ItemInserting(object sender, DetailsViewInsertEventArgs e)
    {
        
        FileUpload FitxerUpload = (FileUpload)DetailsView1.FindControl("FitxerUpload");

        //Comprovem si existeix un fitxer a inserir.
        if (FitxerUpload.HasFile)
        {

            //Es genera la ruta d'accés al fitxer.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Videos/";
            string contingut = FitxersDirectory + FitxerUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(FitxerUpload.FileName);


            //S'emmagatzema el fitxer i la seva ruta d'accés
            FitxerUpload.SaveAs(Server.MapPath(contingut));
            e.Values["contingut"] = contingut;
        }
    }



    //Abans d'inserir un nou registre es carreguen les dades del curs i del tipus de material. 
    protected void Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["codi_curs"] = "1";
        e.InputParameters["tipus"] = "Vídeo";
    }


    //Actualitzem un fitxer de Vídeo.
    protected void ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {
        FileUpload FitxerUpload = (FileUpload)DetailsView1.FindControl("FitxerUpload");
        if (FitxerUpload.HasFile)
        {

            //S'esborra el fitxer antic.
            int codi_material = Convert.ToInt32(e.Keys["codi_material"]);
            int codi_curs = Convert.ToInt32(e.Keys["codi_curs"]);
            MaterialsBLL Materials = new MaterialsBLL();
            Campus.MaterialsDataTable materials = Materials.GetMaterialsByCodiMaterialANDCodiCurs(codi_material, codi_curs);
            Campus.MaterialsRow material = materials[0];
            if (material.IscontingutNull())
                deletedApuntsPath = null;
            else
            {
                deletedApuntsPath = material.contingut;
                System.IO.File.Delete(Server.MapPath(deletedApuntsPath));
            }


            //Es genera la ruta d'accés al fitxer.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Videos/";
            string contingut = FitxersDirectory + FitxerUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(FitxerUpload.FileName);


            //S'emmagatzema el fitxer i la seva ruta d'accés.
            FitxerUpload.SaveAs(Server.MapPath(contingut));
            e.NewValues["contingut"] = contingut;

        }
    
    }


    //Abans d'actualitzar el registre es carreguen les dades del curs i del tipus de material.
    protected void Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["codi_curs"] = "1";
        e.InputParameters["tipus"] = "Vídeo";
    }


    //Inicialitzem  l’accés al fitxer.
    string deletedApuntsPath = null;

    //Esborrament d'un fitxer.
    protected void ItemDeleting(object sender, DetailsViewDeleteEventArgs e)
    {

        //Es determina la ruta d'accés del fitxer associat al registre a eliminar.
        int codi_material = Convert.ToInt32(e.Keys["codi_material"]);
        int codi_curs = Convert.ToInt32(e.Keys["codi_curs"]);
        MaterialsBLL Materials = new MaterialsBLL();
        Campus.MaterialsDataTable materials = Materials.GetMaterialsByCodiMaterialANDCodiCurs(codi_material, codi_curs);
        Campus.MaterialsRow material = materials[0];

        if (material.IscontingutNull())
            deletedApuntsPath = null;
        else
        {
            //Si el fitxer existeix, s'esborra.
            deletedApuntsPath = material.contingut;
            System.IO.File.Delete(Server.MapPath(deletedApuntsPath));
        }

    }


}