﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Cursos_Professorat_Curs_01_Tests_AfegirTest_1 : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    //Abans d'inserir el registre es carreguen les dades del curs. 
    protected void ObjectDataSource109_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["codi_curs"] = "1";
    }


    //Inserim un nou fitxer de Test.
    protected void ItemInserting(object sender, DetailsViewInsertEventArgs e)
    {
        FileUpload TestUpload = (FileUpload)DetailsView1.FindControl("TestUpload");

        //Comprovem si existeix un fitxer a inserir.
        if (TestUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }

            //Es genera la ruta d'accés al fitxer.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Tests/Tests_proposats/";
            string fitxer_test = FitxersDirectory + TestUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(TestUpload.FileName);


            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(TestUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }



            //S'emmagatzema el fitxer i la seva ruta d'accés.
            TestUpload.SaveAs(Server.MapPath(fitxer_test));
            e.Values["fitxer_test"] = fitxer_test;
        }

    }




    protected void DetailsView1_PageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {

    }



    //Esborrament d'un registre.
    string deletedTestPath = null;
    protected void ItemDeleting(object sender, DetailsViewDeleteEventArgs e)
    {
       
        //Es determina la ruta d'accés del fitxer associat al registre a eliminar. 
        int codi_curs = Convert.ToInt32(e.Keys["codi_curs"]);
        int codi_test = Convert.ToInt32(e.Keys["codi_test"]);
        TestsBLL Tests = new TestsBLL();
        Campus.TestsDataTable tests = Tests.GetTestsByCodiTest(codi_curs, codi_test);
        Campus.TestsRow test = tests[0];

        if (test.Isfitxer_testNull())
            deletedTestPath = null;
        else
        {
            //Si el fitxer existeix, s'esborra.
            deletedTestPath = test.fitxer_test;
            System.IO.File.Delete(Server.MapPath(deletedTestPath));
        }
    }




    protected void DetailsView1_PageIndexChanging1(object sender, DetailsViewPageEventArgs e)
    {

    }

    protected void DetailsView1_PageIndexChanging2(object sender, DetailsViewPageEventArgs e)
    {

    }


    protected void ObjectDataSource109_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {

    }


    //Inicialitzem  l’accés al fitxer.
    string deletedTest1Path = null;

    //Actualitzem un fitxer de Tests.
    protected void ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {
        FileUpload NouTestUpload = (FileUpload)DetailsView1.FindControl("NouTestUpload");

        //Comprovem si existeix un nou fitxer.
        if (NouTestUpload.HasFile)
        {
            //Només es permet pujar fitxers en format '.pdf' , '.doc', '.docx'  o  '.odt'.
            if ((string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".pdf", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".doc", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".docx", true) != 0)
                && (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".odt", true) != 0)
                )
            {
                //S’informa dels formats admesos.
                UploadWarning.Text = "Només documents en format '.pdf' , '.doc', '.docx'  o  '.odt'.";
                UploadWarning.Visible = true;
                e.Cancel = true;
                return;
            }


            //S'esborra el fitxer antic.
            int codi_curs = Convert.ToInt32(e.Keys["codi_curs"]);
            int codi_test = Convert.ToInt32(e.Keys["codi_test"]);

            TestsBLL Tests = new TestsBLL();
            Campus.TestsDataTable tests = Tests.GetTestsByCodiTest(codi_curs, codi_test);
            Campus.TestsRow test = tests[0];
            if (test.Isfitxer_testNull())
                deletedTest1Path = null;
            else
            {
                //Si el fitxer existeix, s'esborra.
                deletedTest1Path = test.fitxer_test;
                System.IO.File.Delete(Server.MapPath(deletedTest1Path));
            }




            //Es genera la ruta d'accés al fitxer.
            const string FitxersDirectory = "~/Fitxers/Curs_01/Tests/Tests_proposats/";
            string fitxer_test = FitxersDirectory + NouTestUpload.FileName;
            string fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(NouTestUpload.FileName);


            //Si el nom del fitxer ja existeix en el sistema, es genera un nom nou afegint un número al nom original. 
            if (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".pdf", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".pdf");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".doc", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".doc");
                    iteration++;
                }
            }


            if (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".docx", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".docx");
                    iteration++;
                }
            }

            if (string.Compare(System.IO.Path.GetExtension(NouTestUpload.FileName), ".odt", true) == 0)
            {
                int iteration = 1;

                while (System.IO.File.Exists(Server.MapPath(fitxer_test)))
                {
                    fitxer_test = string.Concat(FitxersDirectory, fileNameWithoutExtension, "-", iteration, ".odt");
                    iteration++;
                }
            }


            //S'emmagatzema el fitxer i la seva ruta d'accés.
            NouTestUpload.SaveAs(Server.MapPath(fitxer_test));
            e.NewValues["fitxer_test"] = fitxer_test;
        }

   
    }



}